/*
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2004 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   ### File Specific:
   main-programmer: Benjamin Grauer
   co-programmer: ...
*/

#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_LOADING

#include "util/loading/load_param_xml.h"
#include "load_param_description.h"

XmlLoadParam::XmlLoadParam(const TiXmlElement* root, const std::string& paramName, BaseObject* object, Executor<const TiXmlElement*>* executor, bool inLoadCycle )
    : LoadParamBase(root, paramName, object, inLoadCycle)
{
  this->executor = executor;
}


XmlLoadParam::~XmlLoadParam()
{
  assert(this->object != NULL);

  (*this->executor)(this->object, this->loadElem);

  delete this->executor;
}
